import java.util.*;
import static java.util.stream.Collectors.*;

public class Sample {  
  public static List<Person> createPeople() {
    return List.of(
	    new Person("Sara", 20),
	    new Person("Sara", 22),
	    new Person("Bob", 20),
	    new Person("Paula", 32),
	    new Person("Paul", 32),
	    new Person("Jack", 2),
	    new Person("Jack", 72),
	    new Person("Jill", 12)
	  );
  }

  public static boolean isOlderThan30(Person person) {
    return person.getAge() > 30;
  }

  public static void main(String[] args) {
    //find the names, in uppercase, of those who are older than 30
    
    //List<String> selected = createPeople().stream()
    //  .filter(person -> person.getAge() > 30)
    //  .map(person -> person.getName())
    //  .map(name -> name.toUpperCase())
    //  .collect(toList()); //collect is a reduce operation

    List<String> selected = createPeople().stream()
      //.filter(person -> person.getAge() > 30)
      .filter(Sample::isOlderThan30)
      .map(Person::getName)
      .map(String::toUpperCase)
      .collect(toList()); //collect is a reduce operation
    
    System.out.println(selected);
  }
}